package starship2d;

import org.lwjgl.input.Keyboard;

public class GameMenu
{
	private static final int START_DELAY = 3;
	private boolean bStart;
	private boolean bEnd;
	private long countdownTime;
	private int countdown;
	private OGLFont font;
	private Player player;
	private StarShip2d mainClass;
	
	public GameMenu(Player pl, StarShip2d sh)
	{
		player = pl;
		mainClass = sh;
		reset();
	}
	
	public void setEnd(boolean end)		{ bEnd = end; }
	public boolean isActive()			{ return bStart || bEnd; }
	public void setFont(OGLFont f)			{ font = f; }
	public void setPlayer(Player p)		{ player = p; }
	
	public void render()
	{
		if (bStart)
		{
			font.print("Game starts in: " + countdown, new Vector2(230,200));
			
			if (countdownTime + Timer.tmrRes <= Timer.frameTime)
			{
				countdownTime = Timer.frameTime;
				countdown--;
			}
			
			if (countdown <= 0)
				bStart = false;
		}
		else if (bEnd)
		{
			Keyboard.poll();

			if(Keyboard.isKeyDown(Keyboard.KEY_TAB))
			{
				reset();
				mainClass.initLayers();
			}
				
			font.print("Game Over", new Vector2(260,150));
			font.print("Your score was: " + player.getScore(), new Vector2(210, 210));
			font.print("Press TAB to play again, Esc to quit", new Vector2(150, 260));
		}
	}
	
	public void reset()
	{
		bStart = true;
		bEnd = false;
		countdownTime = Timer.frameTime;
		countdown = START_DELAY;
	}
	
} // end Menu