//////////////////////////////////////////////////////////////////////////////////////
/*
Author: Henrik Krysell
E-mail: drx@drx.dk
Website: www.drx.dk

Copyright (C) 2004  Henrik Krysell

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
//////////////////////////////////////////////////////////////////////////////////////

/*
	FIXME!
	There are a lot of things to optimize in this class ex:

	* is ArrayList really the best way to go here
*/

package starship2d;


import java.util.*;


public class Layer
{
	// VARIABLES
	private ArrayList objects = new ArrayList();
	
	
	// FUNCTIONS
	Layer()
	{
	}
	
	public void add(Object obj)
	{
		objects.add(obj);
	}
	
	public void init()
	{
		for (int i=0; i < objects.size(); i++)
		{
			((Object)objects.get(i)).init();
		}
	}
	
	public void render()
	{
		for (int i=0; i < objects.size(); i++)
		{
			((Object)objects.get(i)).render();
		}
	}
	
	public void update()
	{
		for (int i=0; i < objects.size(); i++)
		{
			((Object)objects.get(i)).update();
		}
	}
	
	public void destroy()
	{
		for (int i=0; i < objects.size(); i++)
		{
			((Object)objects.get(i)).destroy();
		}
	}
	
	public boolean checkCollision(BoundingBox2 bb, Object obj)
	{
		boolean res = false;
		for (int i=0; (i < objects.size()) && !res; i++)
		{
			if (((Object)objects.get(i)) != obj)
				res = ((Object)objects.get(i)).hit(bb);
		}

		return res;
	}

	public boolean checkSphereCollision(float sqrRad, Vector2 center, Object obj)
	{
		boolean res = false;
		for (int i=0; i < objects.size(); i++)
		{
			if (((Object)objects.get(i)) != obj)
				res = ((Object)objects.get(i)).sphereHit(sqrRad, center) || res;
		}

		return res;
	}
} // end Layer
